#!/oracle/bin/oraperl

$USERID = $ENV{"USERID"};
$PASSWD = $ENV{"PASSWD"};
$MAX_MSGID = 1000000;

#open(STDERR,"> /dev/null");

print "**** logon Oracle ****\n";
$lda = &ora_login($ORACLE_SID,$USERID,$PASSWD) || die $ora_errstr;
$count = 0;

if (!&draft_parse) {
	print "Error in NNTP - aborted !\n";
}
do ora_logoff($lda) || die "can't log off Oracle";
print "\n**** logoff Oracle ****\n";
print "**** Total $count articles parsed ****\n";
exit 0;

#--------------------------------------------------------------------------
# Usage:	&draft_parse();
# Action:	Parse current draft and construct header attributes
#--------------------------------------------------------------------------
sub draft_parse	{
local($i,$key,$value,$out,$state,$len,$fid);
local($p) = ('draft_parse');
local($timezone,$junk);
local($sname,$userid,$email,$a);
local($i_id,$i_folder);
local($chars,$words,$lines);

$state = 0; # 0 - before/between articles; 1 - in an article header; 2 - in an article body
$current_group = "";

while(<STDIN>)	{
	#print $_;
	chop;
	if ($state == 0) {
        	if (/^_TOP_(.+)\s+(\d+)_TOP_$/) {
			$fid = $2; $newsgroup = $1;
			#print "$newsgroup $fid\n";
			@HeaderKeyVec = @HeaderValueVec = @ValueHeightVec = @KeyLabelVec = (); 
			$KeyMaxLength = '';
			$state = 1;
			if ($current_group ne $newsgroup) {
				$current_group = $newsgroup;
				$F_ID = 0;
			}
			%key_value = ("Received","","Message-Id","","To","",
          		"Cc","","Subject","","Date","","From","",
          		"In-Reply-To","","Content-Type","TEXT/PLAIN",
          		"Content-Length","","Size","","Return-Path","",
          		"Message-ID","","Followup-To","","Newsgroups","",
          		"References","","Message-id","","Sender","");
		}
		else  {print "$_\n";}
    	}
	elsif ($state == 1) {
		if(/ERROR_NA$/) { 
			print "Error in [$newsgroup $fid]\n";
			&ora_do($lda,"update folder set max_msgid='$fid' 
				where path='$newsgroup' and max_msgid < '$fid'")|| die $ora_errstr;
			&ora_commit($lda);
			$state = 0;
			next;
		}	
		if(/^([^\s:]+):\s*(.*)\s*$/)	{
			$key = $1; $value = $2;
			$len = length($key);
			if($len > $KeyMaxLength) { $KeyMaxLength = $len; }
	                $key_value{$key} = $value;
			push(@HeaderKeyVec,$key);
			push(@HeaderValueVec,$value);
			push(@ValueHeightVec,$height=1);
		}
		elsif(/^\s*-*\s*$/) { 
			$state = 2; 
			@BodyVec = @Body_Str = ();
			$j = 0;
			$BodyHeight = 0;
			$chars = $words = $lines = $tt = 0;
		}
		else		{
			if(!$key) { 
				print "Error in $p: Header Fmt ($_)\n"; 
				&ora_do($lda,"update folder set max_msgid='$fid' 
					where path='$newsgroup' and max_msgid < '$fid'")|| die $ora_errstr;
				&ora_commit($lda);
				$state = 0;
			}
			else { 
				$value = pop(@HeaderValueVec);
				push(@HeaderValueVec,"$value$_");
				$key_value{$key} = "$value$_";
				$height = pop(@ValueHeightVec);
				push(@ValueHeightVec,$height+1);
			}			
		}
		next;
	}
	elsif ($state == 2) {
		if (!/^_END_(.+)_END_$/) {
			$line_chars = tr///c;
			if (($j < 10) && (($tt + $line_chars) >= 1800)) {
				$Body_Str[$j] = join("\n",@BodyVec);
				$Body_Str[$j] =~ s/'/''/g;
				#$Body_Str[$j] =~ s/\$/\\\$/g; # escape $ for perl			
				#$lines += $BodyHeight;
				@BodyVec = ("\n");
				push(@BodyVec,$_);
				$chars += $tt;
				$_ = "$Body_Str[$j]";
				#$words += tr/ //;
				#$BodyHeight = 1;
				$tt = $line_chars;
				$j++;
			}
			else {
				push(@BodyVec,$_);
				#$BodyHeight++;
				$tt += $line_chars;
     	       		}
		}
		else {
			$state = 0; 
		        $_ = "@BodyVec";
			$chars += $tt;
			#$words += tr/ //;
			$Body_Str[$j] = join("\n",@BodyVec); 
			$Body_Str[$j] =~ s/'/''/g;
			#$lines += $BodyHeight;

			$total_body_field = $j;
			$key_value{"Size"} = $chars;
			if ($key_value{"Message-Id"} eq "") {
				$key_value{"Message-Id"} = $key_value{"Message-ID"};
			}	
			if ($key_value{"Message-Id"} eq "") {
				$key_value{"Message-Id"} = $key_value{"Message-id"};
			}
	
			if ($key_value{"From"} eq "") {
				$key_value{"From"} = $key_value{"Sender"};
			}


			$junk = $key_value{"Date"};
			if ($junk =~ /,/) {	# in case there is no weekday char
				($junk,$key_value{"Date"}) = split(/, /,$key_value{"Date"});
			}
			($key_value{"Date"},$junk) = split(/-/,$key_value{"Date"});
			($key_value{"Date"},$junk) = split(/[+]/,$key_value{"Date"});

			$timezone = $key_value{"Date"};
			$key_value{"Date"} =~ s/:(.*):(.*)/:\1/;  # get rid of seconds
			if ($key_value{"Date"} =~ /:(.*):(.*)/) {
				$key_value{"Date"} = $1;
				$timezone = $2;
			}
			$timezone =~ s/\s*.*([A-Z][A-Z][A-Z]).*/\1/;
			$key_value{"Date"} =~ s/:([0-9]*)\s+(.*)$/:\1/; # get rid of time Zone

			if (!$timezone || !($timezone =~ /AST|ADT|BST|BDT|CST|CDT|EST|EDT|HST|HDT|MST|MDT|NST|PST|PDT|YST|YDT|GMT/)) 
				{$timezone = "EST";}

			$key_value{"Date"} =~ s/^\s*(\d+)\s+([a-zA-Z]+)\s+(\d+)\s+(\d+:\d+)/$1 $2 $3 $4/;
			if ($key_value{"Date"} =~ /^(\d+)\s+([a-zA-Z]+)\s+(\d+)\s+(\d+:\d+)/) {
				if ($3 =~ /^\d\d$/) { $key_value{"Date"} = "$1 $2 19$3 $4";}
				else { $key_value{"Date"} = "$1 $2 $3 $4";}
			}
			else {
				print "Date Format Error in $DraftCur ...\n";
				&ora_do($lda,"update folder set max_msgid='$fid' 
					where path='$newsgroup' and max_msgid < '$fid'")|| die $ora_errstr;
				&ora_commit($lda);
				next;
			}

			if ($key_value{"References"} ne "") {
				$key_value{"In-Reply-To"} = $key_value{"References"};
			}

			$key_value{"In-Reply-To"} =~ s/\n//g;
			$key_value{"In-Reply-To"} =~ s/^(\s|.*)(<.*>)(\s|.)*$/\2/; # only need meg id
			$key_value{"Message-Id"} =~ s/(\s|.*)(<.*>)(\s|.)*$/\2/; # only need meg id

			$key_value{"Subject"} =~ s/'/''/g; # require by plsql for single quote
			$key_value{"From"} =~ s/'/''/g; # require by plsql for single quote
			$key_value{"Message-Id"} =~ s/'/''/g; # require by plsql for single quote
			$key_value{"In-Reply-To"} =~ s/'/''/g; # require by plsql for single quote

			
			$a = $key_value{"From"};
			if ($a =~ /^\s*(.*)<(.*)>\s*$/) {
				$sname = $1;
				$email = $2;
			}
			elsif ($a =~ /^\s*(.*)\s\((.*)\)\s*$/) {
				$sname = $2;
				$email = $1;
			}
			elsif ($a =~ /^\s*(.*)\((.*)\)\s*$/) {
				$sname = $2;
				$email = $1;
			}
			else {	
				$sname = "";
				$email = $a;
			}
			$sname =~ s/\s*$//;
			$sname =~ s/"//g;
			$email =~ s/\s*$//;
			$email =~ s/^\s*//;
			$email =~ s/<//g;
			$email =~ s/>//g;
			($userid,$a) = split(/@/,$email);
			if ($userid eq "") {
				if ($email eq "") {
					print "Bad msg header $fid\n"; 
					next;
				}
				$userid = $email;
			}

			if ($key_value{"Cc"} eq "") {
			$key_value{"Cc"} = $key_value{"Followup-To"};
			}
			if ($key_value{"To"} eq "") {
				$key_value{"To"} = $key_value{"Newsgroups"};
			}
			$key_value{"To"} =~ s/'/''/g; # require by plsql for single quote
			if (length($key_value{"To"}) >= 2000) { 
				$key_value{"To"} = substr($key_value{"To"},0,2000);
				$key_value{"To"} =~ s/,(\w+)$//;
			}
			$key_value{"Cc"} =~ s/'/''/g; # require by plsql for single quote
			if (length($key_value{"Cc"}) >= 2000) { 
				$key_value{"Cc"} = substr($key_value{"Cc"},0,2000);
				$key_value{"Cc"} =~ s/,(\w+)$//;
			}

			$key_value{"Content-Type"} = ""; # ignore this field for the time-being

#print "i_id=>'$fid',
#i_msg_date=>'$key_value{\"Date\"}',i_subject=>'$key_value{\"Subject\"}',
#i_sender=>'$email',i_receiver=>'$key_value{\"To\"}',
#i_msg_id=>'$key_value{\"Message-Id\"}',i_bytes=>'$key_value{\"Size\"}',
#i_body_type=>'$key_value{\"Content-Type\"}',i_folder=>'$newsgroup',
#i_replied_id=>'$key_value{\"In-Reply-To\"}',
#i_timezone=>'$timezone',i_cc=>'$key_value{\"Cc\"}',
#uid=>'$userid',sname=>'$sname',email=>'$email');\n";

#&ora_do($lda,<<END_OF_PLSQL1)|| die $ora_errstr;

$err = &ora_do($lda,<<END_OF_PLSQL1);
begin
MAILS.insert_header(i_id=>'$fid',
	    i_msg_date=>'$key_value{"Date"}',i_subject=>'$key_value{"Subject"}',
            i_sender=>'$email',i_receiver=>'$key_value{"To"}',
	    i_msg_id=>'$key_value{"Message-Id"}',i_bytes=>'$key_value{"Size"}',
	    i_body_type=>'$key_value{"Content-Type"}',i_folder=>'$newsgroup',
	    i_replied_id=>'$key_value{"In-Reply-To"}',
	    i_timezone=>'$timezone',i_cc=>'$key_value{"Cc"}',
	    uid=>'$userid',sname=>'$sname',email=>'$email');
commit;
end;
END_OF_PLSQL1


if (!$err) {

	print "error while inserting $newsgroup $fid header\n";
	#exit;
	next;
}

# $err = &ora_do($lda,<<END_OF_PLSQL2);
&ora_do($lda,<<END_OF_PLSQL2) || die $ora_errstr;
begin
MAILS.insert_body(i_id=>'$fid',i_body_type=>'$key_value{"Content-Type"}',
	i_chars=>$chars,i_words=>$words,i_lines=>$lines,i_folder=>'$newsgroup');
commit;
end;
END_OF_PLSQL2

if (!$err) {

# Chao-Wei Ou added for debugging the values from parser
print qq|\n-- HEAD --\n\n|;
print qq|id: $fid\n|;
print qq|date: $key_value{"Date"}\n|;
print qq|subject: $key_value{"Subject"}\n|;
print qq|sender: $email\n|;
print qq|receiver: $key_value{"To"}\n|;
print qq|msg_id: $key_value{"Message-Id"}\n|;
print qq|bytes: $key_value{"Size"}\n|;
print qq|body_type: $key_value{"Content-Type"}\n|;
print qq|folder: $newsgroup\n|;
print qq|replied_id: $key_value{"In-Reply-To"}\n|;
print qq|timezone: $timezone\n|;
print qq|cc: $key_value{"Cc"}\n|;
print qq|uid: $userid\n|;
print qq|sname: $sname\n|;
print qq|email: $email\n\n|;
print qq|-- BODY --\n\n|;
print qq|fid: $fid\n|;
print qq|body_type: $key_value{"Content-Type"}\n|;
print qq|chars: $chars\n|;
print qq|words: $words\n|;
print qq|lines: $lines\n|;
print qq|folder: $newsgroup\n\n|;
# End of debugging

	print "error while inserting $newsgroup $fid body\n";
	return 0;
	next;
}

			#print "$newsgroup $fid done\n";
			if ($F_ID == 0) {
				$csr = &ora_open($lda,"select id from folder where path='$newsgroup'")|| die $ora_errstr;
				($F_ID) = &ora_fetch($csr);	
				do ora_close($csr) || die "can't close cursor";
				$F_ID = ($F_ID - 1)*$MAX_MSGID;
				#print "get F_ID = $F_ID\n";
			}

			$id = $F_ID + $fid;

#print "update body set msg_body1='$Body_Str[0]',msg_body2='$Body_Str[1]',
#msg_body3='$Body_Str[2]',msg_body4='$Body_Str[3]',msg_body5='$Body_Str[4]',
#msg_body6='$Body_Str[5]',msg_body7='$Body_Str[6]',msg_body8='$Body_Str[7]',
#msg_body9='$Body_Str[8]',msg_body10='$Body_Str[9]' where id = $id);\n";

			&ora_do($lda,"update body set msg_body1='$Body_Str[0]',msg_body2='$Body_Str[1]',
			msg_body3='$Body_Str[2]',msg_body4='$Body_Str[3]',msg_body5='$Body_Str[4]',
			msg_body6='$Body_Str[5]',msg_body7='$Body_Str[6]',msg_body8='$Body_Str[7]',
			msg_body9='$Body_Str[8]',msg_body10='$Body_Str[9]' where id = $id");

			&ora_commit($lda);
			if ($total_body_field == 10) {
                                $Body_Str[10] = substr($Body_Str[10],0,32000);  # 32k limit in PL/SQL long variable
                                $nn = length($Body_Str[10]);
                                print "Length = $nn\n";
                                &ora_do($lda,"update body set msg_body11='$Body_Str[10]' where id = $id");
			}

			&ora_do($lda,"update folder set max_msgid='$fid' where path='$newsgroup'")|| die $ora_errstr;
			&ora_commit($lda);
			$count += 1;
		}
	}
}
return 1;
}
