/*        file: main.c
          adopted by: Gang Cheng from Johan Svensson <johan@ecsdg.lu.se>
    email to: <gcheng@npac.syr.edu>
        date: 1995-08-14
 last update: 1995-08-15
       notes: Main file for project NOW (Newsgroups in Oracle and Web)
*/

#include "generic.h"
#include "main.h"
#include "nntp.h"

UDWORD  maxart;
UWORD   runmode, nothtml;

/*static char  nntpserver[511] = "crpc2.npac.syr.edu";*/
static char  nntpserver[511] = "128.230.164.211";
/* unused for now: */
static char  nntpport[12]= "119";
static char  groupname[255];
struct group {
	char *name;
	UDWORD min_id;
	UDWORD max_id;
};
static struct group newsgroup[255]; 

/* get the min and max id of this group */
UWORD getgroup(char *name,UDWORD *minid,UDWORD *maxid) {
   static char  tmp[511], command[255];
   UDWORD retvalue;
   UDWORD total_art;

   strnset(command, '\0', strlen(command));   
   strnset(tmp, '\0', strlen(tmp));
   retvalue = 0;

   sprintf(command, "GROUP %s", name);
   put_server(command);
   get_server(tmp, sizeof(tmp));
   sscanf(tmp, "%d", &retvalue);
   if (retvalue != OK_GROUP) {
      	if (reconnect_server(nntpserver) < 0) {
      		fprintf(stdout,"NNTP ERROR_NA\n");
         	return -1;
      	}
      	strnset(tmp, '\0', strlen(tmp));
      	put_server(command);
      	get_server(tmp, sizeof(tmp));
      	sscanf(tmp, "%d", &retvalue);
      	if (retvalue != OK_GROUP) {
		fprintf(stdout,"GROUP ERROR_NA\n");
         	return 0;
      	}
   }

   sscanf(tmp, "%*d%d%d%d", &total_art, minid, maxid);
   return 1;
}

UDWORD getarticle(char *name,UDWORD minid,UDWORD maxid) {
/* get the contents of this group */

   UDWORD tempi, i, retvalue;
   UDWORD msgid;
   static char  tmp[511], command[255];
   UDWORD total = 0;

   for (msgid=minid;msgid <= maxid; msgid++) {
	strnset(command, '\0', strlen(command));   
   	strnset(tmp, '\0', strlen(tmp));
   	retvalue = 0;
	sprintf(command, "ARTICLE %d", msgid);
        put_server(command);
        get_server(tmp, sizeof(tmp));
        sscanf(tmp, "%d", &retvalue);
        if (retvalue != OK_ARTICLE) {
	 	fprintf(stdout,"ARTICLE ERROR_NA\n");
	}
        else {
               /* Read article from server and write to stdout: */
               fprintf(stdout, "_TOP_%s %ld_TOP_\n",name,msgid);
               for (;;) {
                  strnset(tmp, '\0', strlen(tmp));
                  get_server(tmp, sizeof(tmp));
                  if ((tmp[0] == '.') && (tmp[1] =='\0'))
                     break;
                  fprintf(stdout, "%s\n", tmp);
	       }
	       fprintf(stdout, "_END_%s %ld_END_\n",name,msgid);
	       
	       total++;
        }
	fflush(stdout);
   }
   return total;
}


UWORD showproginfo(void) {
/* Give a link for more information about the program */

   fprintf(stderr,"%s v%s - archive a Usenet News group\n\n", PRGNAME,
      NewsArchiveVERSION);
   fprintf(stderr,"Usage:\n");
   fprintf(stderr,"    %s <newsgroup> \n", PRGNAME);
   fprintf(stderr,"        <newsgroup> <maxid in db>   Run %s as the file tells it to\n\n",
      PRGNAME);
   return (0);
}



/* MAIN FUNCTION */
int main (int argc, char *argv[]) {

   FILE *fp;
   char groupname[255];
   UWORD retvalue;
   UDWORD maxid_db,minid,maxid,total,total_in_group,i,n;

   if (argc != 2) {
      showproginfo();
      return 1;
   }

   if ((fp=fopen(argv[1],"r")) == NULL) {
       fprintf(stderr,"Unable to open %s\n",argv[1]);
       return 1;
   }

   n = 0;
   i = 0;
   /*printf("in group file:\n");*/
   while (fscanf(fp,"%s\n",groupname) != EOF) {
        strcpy(newsgroup[i].name=(char *)malloc(sizeof(groupname)+1),groupname);
	newsgroup[i++].max_id = 0;
	/*printf("%s\n",groupname);*/
   }

   n = i;
  /* printf("in DB folder:\n"); */
   while (fscanf(stdin,"%s %ld\n",groupname,&maxid_db) != EOF) {
	/*printf("%s %ld\n",groupname,maxid_db);*/
	for (i=0; i<n; i++) 
		if (strcmp(groupname,newsgroup[i].name) == 0) {
		 	newsgroup[i].max_id = maxid_db;
			break;
		}
   }

   /* Connect to NNTP server: */
   if (connect_server(nntpserver) < 0) {
      fprintf(stdout,"NNTP ERROR_NA\n");
      return 1;
   }
   fprintf(stdout,"News Server (%s) opened\n",nntpserver); 
   /*printf("final:\n");*/
   total = 0;
   for (i=0; i<n; i++) {
        /*printf("%s %ld %ld\n",newsgroup[i].name,newsgroup[i].min_id,newsgroup[i].max_id);*/
        if ((retvalue = getgroup(newsgroup[i].name,&minid,&maxid)) > 0) {
		maxid_db = newsgroup[i].max_id;
		if (maxid_db >= maxid) {
			newsgroup[i].min_id = -1;
			newsgroup[i].max_id = -1; 
		}
		else if (maxid_db < minid) {
			newsgroup[i].min_id = minid;
			newsgroup[i].max_id = maxid;
		}
		else  {
			newsgroup[i].min_id = maxid_db + 1;
			newsgroup[i].max_id = maxid;
		}
	}
	else if (retvalue == 0) {
			newsgroup[i].min_id = -1;
			newsgroup[i].max_id = -1; 
	}
	else  {
		close_server();
		fprintf(stdout,"News Server (%s) closed\n",nntpserver); 
		return 1;
	}	
	if (newsgroup[i].max_id == -1) {
		fprintf(stdout,"no new article in %s\n",newsgroup[i].name);
	}
	else {
		fprintf(stdout,"%s %ld %ld\n",newsgroup[i].name,newsgroup[i].min_id,newsgroup[i].max_id);
		if ((total_in_group = getarticle(newsgroup[i].name,newsgroup[i].min_id,
			newsgroup[i].max_id)) < 0) {
			close_server();
			fprintf(stdout,"News Server (%s) closed\n",nntpserver); 
			return 1;
		}	
		fprintf(stdout,"%s: total %ld loaded\n",newsgroup[i].name,total_in_group);	
		total += total_in_group;
	}
   }

   printf("Total %ld articles gathered\n",total);

   /* Close connection: */
   close_server();
   fprintf(stdout,"News Server (%s) closed\n",nntpserver); 
   /* OK, everything was run smoothly: */
   return 0;
}

